import java.util.*;
import java.util.stream.*;



public class Main {
    static class Edge {
        int m, s, f;
    
        public Edge(int m, int s, int f) {
            this.m = m;
            this.s = s;
            this.f = f;
        }
    
        @Override
        public String toString() {
            return shuffleCases("Kaban") + '-' + m + ' ' + s + ' ' + f;
        }
    }
    
    private static String shuffleCases(String str) {
        Random rng = new Random(System.nanoTime());
        return str.chars()
                .mapToObj(c -> (char) c)
                .map(c -> rng.nextBoolean() ? Character.toLowerCase(c) : Character.toUpperCase(c))
                .map(String::valueOf)
                .collect(Collectors.joining());
    }

    private static int gcd(int a, int b) {
        while (b != 0) {
            int temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        List<Integer> a = IntStream.rangeClosed(1, n)
                .map(i -> scanner.nextInt())
                .boxed()
                .collect(Collectors.toList());
        int s = scanner.nextInt();
        int f = scanner.nextInt();
        List<Edge> edges = new ArrayList<>();

        while (s != f) {
            int c = s;
            int m = 0;
            while (c != f) {
                int cc = c < f ? c + 1 : c - 1;
                int aa = Math.abs(a.get(c - 1) - a.get(cc - 1));
                if (aa == 1) {
                    System.out.println(shuffleCases("Impossible"));
                    return;
                }
                int mm = gcd(m, aa);
                if (mm == 1) break;
                m = mm;
                c = cc;
            }
            if (m == 0) m = 1000000000;
            edges.add(new Edge(m, s, c));
            s = c;
        }

        edges.forEach(System.out::println);
    }
}

