import sys

#magic array from SPOJ problem PKPLOL
a = ["abcdef", "bc", "abdeg", "abcdg", "bcfg", "acdfg", "acdefg", "abc", "abcdefg", "abcdfg"]
ORDER = 'afbgecd'

def parse_broken(s):
  return set(c for c, d in zip(ORDER, s.rstrip()) if d == '0')

def show_digit(d, broken_set):
  s = set(a[d]) - broken_set
  for i, t in enumerate(a):
    if set(t) == s:
      return i
  return None

def show_number(num, broken_sets):
  x, y = divmod(num, 10)
  if x > 0:
    x = show_digit(x, broken_sets[0])
    if (x is None) or (x == 0):
      return None
  y = show_digit(y, broken_sets[1])
  if y is None:
    return None
  return x * 10 + y

def main():
  s = list(map(parse_broken, sys.stdin.readlines()))
  b = [show_number(x, s) for x in range(99, 0, -1)]
  l = 0
  for i, x in enumerate(b):
    if x is None:
      continue
    j = i + 1
    while (j < len(b)) and (x + (j - i)) == b[j]:
      j += 1
    l = max(l, j - i - 1)
  print(l)

main()