#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

const int full = (1 << 7) - 1;
int take (const int i)
{
    return (1 << i);
}

bool bit (const int mask, const int i)
{
    return bool((mask >> i) & 1);
}

const array<int, 10> base_masks = {full - take(3), take(2) + take(5), full - take(1) - take(5),
                              full - take(1) - take(4), take(1) + take(2) + take(3) + take(5),
                              full - take(2) - take(4), full - take(2), take(0) + take(2) + take(5),
                              full, full - take(4)};

/// Intentionally checks a lot of extraneous stuff.
int good_check (const array<int, 2> &alive_inds, const array<int, 10> &masks)
{

    const int nothing = -1;
    const int bad = -2;

    auto how_digit_looks = [&] (const int x, const int pos) -> int
    {
        assert(0 <= x && x <= 9);
        const int mask = (alive_inds[pos] & masks[x]);
        if (mask == 0)
            return nothing;

        const int where = int(find(masks.begin(), masks.end(), mask) - masks.begin());
        if (where == int(masks.size()))
            return bad;
        return where;
    };

    auto how_number_looks = [&] (const int x) -> int
    {
        assert(1 <= x && x <= 99);

        const int fst = (x < 10 ? nothing : how_digit_looks(x / 10, 0));
        const int snd = how_digit_looks(x % 10, 1);

        if ((fst == bad || fst == 0) || (snd == bad || snd == nothing))
            return bad;

        assert(0 <= snd && snd < 9);
        int ans = snd;
        if (fst != nothing)
        {
            assert(1 <= fst && fst <= 9);
            ans += 10 * fst;
        }

        if (ans == 0)
            return bad;

        return ans;
    };

    int ans = 0;
    for (int x = 1; x <= 99; x++)
    {
        const int y = how_number_looks(x);
        for (int k = 1; ; k++)
        {
            const int nx = x - k;
            if (nx >= 1 && how_number_looks(nx) == y + k)
                ans = max(ans, k);
            else
                break;
        }
    }

    return ans;
}

void solve_test(istream &cin = std::cin, ostream &cout = std::cout)
{
    array<int, 2> alive_inds{0, 0};

    for (int i = 0; i < 2; i++)
    {
        string s;
        cin >> s;
        assert(s.size() == 7U);
        for (int j = 0; j < 7; j++)
        {
            assert(s[j] == '0' || s[j] == '1');
            if (s[j] == '1')
                alive_inds[i] |= take(j);
        }
    }

    const int ans = good_check(alive_inds, base_masks);
    cout << ans << endl;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
    solve_test(cin, cout);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;

#ifdef LOCAL
    auto st = clock();

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    do
    {
        solve(fin, fout);

        fout << "===" << endl;

        string str;
        while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
    }
    while (fin);

    cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
    solve();
#endif

    return 0;
}
