#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

const int mod = 998244353;

void add (int &a, const int b)
{
    a += b;
    if (a >= mod)
        a -= mod;
}
void sub (int &a, const int b)
{
    a -= b;
    if (a < 0)
        a += mod;
}
int mult (const int a, const int b)
{
    return int(ll(a) * b % mod);
}

void solve_test(istream &cin = std::cin, ostream &cout = std::cout)
{
    int r, g, b;
    cin >> r >> g >> b;

    auto state = [&] (const int x, const int y, const int z, const int col)
    {
        return (x * (g + 2) * (b + 2) * 3) + (y * (b + 2) * 3) + (z * 3) + col;
    };

    vector<int> dp((r + 2) * (g + 2) * (b + 2) * 3);
    dp[state(1, 0, 0, 0)] = 1;
    dp[state(0, 1, 0, 1)] = 1;
    dp[state(0, 0, 1, 2)] = 1;

    for (int x = 0; x <= r; x++)
    for (int y = 0; y <= g; y++)
    for (int z = 0; z <= b; z++)
    for (int last_col = 0; last_col < 3; last_col++)
    {
        const int cur = dp[state(x, y, z, last_col)];

        if (last_col != 0)
            add(dp[state(x + 1, y, z, 0)], cur);
        if (last_col != 1)
            add(dp[state(x, y + 1, z, 1)], cur);
        if (last_col != 2)
            add(dp[state(x, y, z + 1, 2)], cur);
    }

    int ans = 0;
    for (int last_col = 0; last_col < 3; last_col++)
        add(ans, dp[state(r, g, b, last_col)]);
    cout << ans << endl;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
    solve_test(cin, cout);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;

#ifdef LOCAL
    auto st = clock();

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    do
    {
        solve(fin, fout);

        fout << "===" << endl;

        string str;
        while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
    }
    while (fin);

    cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
    solve();
#endif

    return 0;
}
