#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

const int mod = 998244353;

void add (int &a, const int b)
{
    a += b;
    if (a >= mod)
        a -= mod;
}
void sub (int &a, const int b)
{
    a -= b;
    if (a < 0)
        a += mod;
}
int mult (const int a, const int b)
{
    return int(ll(a) * b % mod);
}

/// Does not work if zeroes are allowed in the input!
void solve_test(istream &cin = std::cin, ostream &cout = std::cout)
{
    int r, g, b;
    cin >> r >> g >> b;

    const int bnd = r + g + b + 1;
    vector<int> fact(bnd, 1), inv(bnd, 1), ifact(bnd, 1);
    for (int i = 2; i < bnd; i++)
    {
        fact[i] = mult(i, fact[i - 1]);
        inv[i] = mod - mult(mod / i, inv[mod % i]);
        assert(mult(i, inv[i]) == 1);
        ifact[i] = mult(inv[i], ifact[i - 1]);
        assert(mult(fact[i], ifact[i]) == 1);
    }

    vector<int> pw2(bnd, 1);
    for (int i = 1; i < bnd; i++)
        pw2[i] = mult(2, pw2[i - 1]);

    auto C = [&] (const int from, const int what)
    {
        if (from < 0 || what > from)
            return 0;
        return mult(fact[from], mult(ifact[what], ifact[from - what]));
    };

    auto in_segments = [&] (const int cnt)
    {
        const int need_odd = abs(g - b);

        int ans = 0;
        for (int odd = need_odd; odd <= cnt; odd += 2)
        {
            const int even = cnt - odd;
            const int extra_odd = odd - need_odd;
            assert(extra_odd % 2 == 0);

            int cur = C(odd, extra_odd / 2);
            cur = mult(cur, C(cnt, odd));
            cur = mult(cur, pw2[even]);

            const int remain_balls = (g + b) - (odd * 1 + even * 2);
            assert(remain_balls % 2 == 0);
            if (remain_balls < 0)
                continue;

            const int buffs = remain_balls / 2;
            cur = mult(cur, C(buffs + cnt - 1, buffs));

            add(ans, cur);
        }

        return ans;
    };

    int ans = in_segments(r + 1);
    add(ans, mult(2, in_segments(r)));
    add(ans, in_segments(r - 1));
    cout << ans << endl;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
    solve_test(cin, cout);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;

#ifdef LOCAL
    auto st = clock();

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    do
    {
        solve(fin, fout);

        fout << "===" << endl;

        string str;
        while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
    }
    while (fin);

    cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
    solve();
#endif

    return 0;
}
