// Author: Ivan Kazmenko (gassa@mail.ru)
// Validator for problem "count-operations"
module validate;
import std.algorithm;
import std.conv;
import std.exception;
import std.stdio;
import std.regex;
import testlib;

immutable int minV =       0;
immutable int maxV = 10 ^^ 9;
immutable int minK =       0;
immutable int maxK = 10 ^^ 5;

void main (string [] args)
{
	initTestlib !(TestlibRole.validator) (args);

	auto start = inFile.readln;
	int n;
	enum forLine = ctRegex !(r"^for \(int i = 0; i < (\d+); i\+\+\) \{$");
	auto forMatch = start.matchFirst (forLine);
	debug {writeln (forMatch);}
	n = forMatch[1].to !(int);
	enforce (minV < n && n <= maxV);

	enum ifLine = ctRegex !(r"^    if \(i == (\d+)\) i = (\d+);$");
	int k = 0;
	while (true)
	{
		auto next = inFile.readln;
		if (next == "    work (i);")
		{
			break;
		}
		auto ifMatch = next.matchFirst (ifLine);
		debug {writeln (ifMatch);}
		auto x = ifMatch[1].to !(int);
		auto y = ifMatch[2].to !(int);
		enforce (minV <= x && x < n);
		enforce (minV <= y && y < n);
		k += 1;
	}
	enforce (minK <= k && k <= maxK);
	inFile.skip ("}\n");

	inFile.checkEof ();
}
