// Author: Ivan Kazmenko (gassa@mail.ru)
module solution;
import std;

alias Line = Tuple !(int, q{x}, int, q{y});
alias State = Tuple !(int, q{i}, int, q{p});

long solve (int n, Line [] d)
{
	d ~= Line (n - 1, 0);
	auto k = d.length.to !(int);
	auto a = k.iota.map !(j => State (d[j].x, j)).array.sort;
	auto vis = new bool [k];
	long res = 3;
	auto s = State (0, -1);
	while (s.p < k - 1)
	{
		auto t = a.upperBound (s).front;
		if (vis[t.p])
		{
			return -1;
		}
		vis[t.p] = true;
		res += (t.i - s.i) * (k + 2L) + (t.p - s.p + 1);
		s = State (d[t.p].y, t.p);
	}
	return res;
}

void main ()
{
	string title;
	while ((title = readln.stripRight) != "")
	{
		int n;
		title.formattedRead !("for (int i = 0; i < %d; i++)") (n);
		Line [] d;
		while (true)
		{
			auto line = readln.stripRight;
			if (line == "    work (i);")
			{
				enforce (readln.stripRight == "}");
				break;
			}
			d.length += 1;
			line.formattedRead !("    if (i == %d) i = %d;")
			    (d.back.x, d.back.y);
		}
		writeln (solve (n, d));
	}
}
