#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

ll brute (const int n, const vector<int> &x, const vector<int> &y)
{
    const int ops = int(x.size());
    for (int i = 0; i < ops; i++)
    {
        assert(0 <= x[i] && x[i] < n);
        assert(0 <= y[i] && y[i] < n);
    }

    vector<bool> started_at(n + 1, false);

    /// int i = 0
    ll ans = 1;
    int pos = 0;

    while (true)
    {
        if (started_at[pos])
            return -1LL;

        started_at[pos] = true;
        /// i < n
        ans++;
        if (pos == n)
            break;

        for (int i = 0; i < ops; i++)
        {
            /// (i == cur_x)
            ans++;
            if (pos == x[i])
            {
                pos = y[i];
                /// (i = cur_y)
                ans++;
            }
        }

        /// work(i)
        ans++;

        pos++;
        /// i++
        ans++;
    }

    return ans;
}

void solve_test(istream &cin = std::cin, ostream &cout = std::cout)
{
    string text;
    string s;

    do
    {
        cin >> s;
        text += s;
    } while (s != "}");

    for (char &ch : text)
    if (ch < '0' || ch > '9')
        ch = ' ';

    stringstream nums_str(text);

    vector<int> nums;
    int nxt;
    while (nums_str >> nxt)
        nums.push_back(nxt);

    assert(nums.size() % 2U == 0);
    assert(nums.size() >= 2U);
    assert(nums[0] == 0);

    int n = nums[1];
    vector<int> x, y;
    for (int i = 2; i < int(nums.size()); i += 2)
    {
        x.push_back(nums[i]);
        y.push_back(nums[i + 1]);
    }

    const auto ans = brute(n, x, y);
    cout << ans << endl;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
    solve_test(cin, cout);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;

#ifdef LOCAL
    auto st = clock();

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    do
    {
        solve(fin, fout);

        fout << "===" << endl;

        string str;
        while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
    }
    while (fin);

    cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
    solve();
#endif

    return 0;
}
