#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

ll work (const int n, const vector<int> &x, const vector<int> &y)
{
    const int ops = int(x.size());

    map<int, pair<int, int>> extra;
    for (int i = ops - 1; i >= 0; i--)
    {
        auto it = extra.find(y[i]);
        if (it != extra.end())
            extra[x[i]] = pair<int, int>((it->second).first, (it->second).second + 1);
        else
            extra[x[i]] = pair<int, int>(y[i], 1);
    }

    for (auto &pr : extra)
        pr.second.first++;

    vector<pair<int, int>> evs;
    evs.emplace_back(n, 1);
    evs.emplace_back(0, 0);
    for (const auto &pr : extra)
    {
        evs.emplace_back(pr.first, 1);
        evs.emplace_back(pr.second.first, 0);
    }

    sort(evs.begin(), evs.end());
    map<int, int> next;

    for (int i = int(evs.size()) - 1, cur = -1; i >= 0; i--)
    {
        if (evs[i].second == 0)
        {
            assert(cur != -1);
            next[evs[i].first] = cur;
        }
        else
            cur = evs[i].first;
    }

    const int default_cost = ops + 3;

    int pos = 0;
    ll ans = 2;
    set<int> visited;

    while (true)
    {
        if (visited.count(pos))
            return -1LL;

        visited.insert(pos);
        assert(next.count(pos));

        const int to = next.at(pos);
        assert(to >= pos);
        ans += ll(to - pos) * default_cost;

        if (to == n)
            break;
        else
        {
            assert(extra.count(to));
            ans += default_cost + extra.at(to).second;
            pos = extra.at(to).first;
        }
    }

    return ans;
}

void solve_test(istream &cin = std::cin, ostream &cout = std::cout)
{
    string text;
    string s;

    do
    {
        cin >> s;
        text += s;
    } while (s != "}");

    for (char &ch : text)
    if (ch < '0' || ch > '9')
        ch = ' ';

    stringstream nums_str(text);

    vector<int> nums;
    int nxt;
    while (nums_str >> nxt)
        nums.push_back(nxt);

    assert(nums.size() % 2U == 0);
    assert(nums.size() >= 2U);
    assert(nums[0] == 0);

    int n = nums[1];
    vector<int> x, y;
    for (int i = 2; i < int(nums.size()); i += 2)
    {
        x.push_back(nums[i]);
        y.push_back(nums[i + 1]);
    }

    const auto ans = work(n, x, y);
    cout << ans << endl;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
    solve_test(cin, cout);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;

#ifdef LOCAL
    auto st = clock();

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    do
    {
        solve(fin, fout);

        fout << "===" << endl;

        string str;
        while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
    }
    while (fin);

    cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
    solve();
#endif

    return 0;
}
