\documentclass [11pt, a4paper, oneside] {article}

\usepackage [LSBC1,T2A] {fontenc}
\usepackage [utf8] {inputenc}
\usepackage [english, russian] {babel}
\usepackage {amsmath}
\usepackage {amssymb}
\usepackage <#if contest.language?? && contest.language="russian">[russian]<#elseif contest.language?? && contest.language="ukrainian">[ukrainian]</#if>{olymp}
\usepackage {comment}
\usepackage {epigraph}
\usepackage {expdlist}
\usepackage {graphicx}
\usepackage {multirow}
\usepackage {siunitx}
\usepackage {ulem}
%\usepackage {hyperref}
\usepackage {import}
\usepackage {ifpdf}
\usepackage {xparse}
\ifpdf
  \DeclareGraphicsRule{*}{mps}{*}{}
\fi


%%% Adding chess
\RequirePackage{xskak,chessboard}

\setboardfontencoding{LSBC1}
\cbDefineNewPiece{white}{W}
{\raisebox{\depth+2pt}{\rotatebox[origin=c]{180}{\WhiteRookOnWhite}}}
{\BlackEmptySquare%
\makebox[0pt][r]{
\raisebox{\depth+2pt}{%
\makebox[1em]{\rotatebox[origin=c]{180}{\WhiteRookOnWhite}}}}}
\cbDefineNewPiece{white}{L}
{\raisebox{\depth+2pt}{\rotatebox[origin=c]{180}{\WhiteKnightOnWhite}}}
{\BlackEmptySquare%
\makebox[0pt][r]{
\raisebox{\depth+2pt}{%
\makebox[1em]{\rotatebox[origin=c]{180}{\WhiteKnightOnWhite}}}}}


\begin {document}

\contest
{${contest.name!}}%
{${contest.location!}}%
{${contest.date!}}%

\binoppenalty=10000
\relpenalty=10000

\renewcommand{\t}{\texttt}
\renewcommand{\thefootnote}{\fnsymbol{footnote}}

<#if shortProblemTitle?? && shortProblemTitle>
  \def\ShortProblemTitle{}
</#if>

<#list statements as statement>
<#if statement.path??>
\graphicspath{{${statement.path}}}
<#if statement.index??>
  \def\ProblemIndex{${statement.index}}
</#if>
\import{${statement.path}}{./${statement.file}}
<#else>
\input ${statement.file}
</#if>
</#list>

\end {document}
