pub use self::template::*;
use std::io::{stdin, stdout, BufWriter, Write};

const BND: usize = 130;

fn solve_test(
    mem: &[Vec<u64>],
    scan: &mut impl Scanner,
    cout: &mut impl Write,
) -> Result<(), std::io::Error> {
    let n: u64 = scan.next();
    let k: usize = scan.next();

    let k = (2 * k).min(mem.len() - 2);

    if k == 2 {
        let mut r = n - 1;
        let mut l = 0;

        while l + 1 < r {
            let t = (l + r) / 2;

            if (t.saturating_mul(t - 1) / 2).saturating_add(t + 1) >= n {
                r = t;
            } else {
                l = t;
            }
        }

        writeln!(cout, "{}", r)
    } else {
        writeln!(cout, "{}", mem[k + 1].binary_search(&n).unwrap_or_else(|x| x))
    }
}

pub fn solve(scan: &mut impl Scanner, cout: &mut impl Write) {
    let mut choose = vec![vec![0u64]; BND];
    choose[0][0] = 1;

    'outer: loop {
        choose[0].push(1);

        for j in 1..BND {
            let n = choose[j].len();

            let val = choose[j - 1][n - 1].saturating_add(choose[j][n - 1]);

            if val == u64::MAX {
                if j <= 4 {
                    break 'outer;
                }

                break;
            }

            choose[j].push(val);
        }
    }

    let mut ps = vec![vec![]; BND + 1];
    ps[0] = vec![0u64; choose[0].len()];
    for k in 1..ps.len() {
        ps[k] = ps[k - 1]
            .iter()
            .zip(choose[k - 1].iter())
            .map(|(a, b)| a.saturating_add(*b))
            .collect();
    }

    let t = scan.next();

    for _test in 0..t {
        solve_test(&ps, scan, cout).unwrap();
    }

    cout.flush().unwrap();
}

#[allow(dead_code)]
fn main() {
    solve(
        &mut IOScanner::new(stdin().lock()),
        &mut BufWriter::new(stdout().lock()),
    );
}

pub mod template {
    use std::io::BufRead;
    use std::str::FromStr;

    pub trait Scanner {
        fn checked_next_line(&mut self) -> Option<String>;

        fn checked_next<T: FromStr>(&mut self) -> Option<T>;

        fn next<T: FromStr>(&mut self) -> T;

        fn seek(&mut self) -> bool;
    }

    pub struct IOScanner<ReadType: BufRead> {
        read: ReadType,
        buffer: Vec<String>,
    }

    impl<ReadType: BufRead> Scanner for IOScanner<ReadType> {
        fn checked_next_line(&mut self) -> Option<String> {
            self.buffer.clear();
            let mut input = String::new();
            if self.read.read_line(&mut input).expect("Failed read") > 0 {
                Some(input)
            } else {
                None
            }
        }

        fn checked_next<T: FromStr>(&mut self) -> Option<T> {
            loop {
                if let Some(token) = self.buffer.pop() {
                    return Some(token.parse().ok().expect("Failed parse"));
                }
                if let Some(input) = self.checked_next_line() {
                    self.buffer = input.split_whitespace().rev().map(String::from).collect();
                } else {
                    return None;
                }
            }
        }

        fn next<T: FromStr>(&mut self) -> T {
            self.checked_next().expect("Read after EOF")
        }

        fn seek(&mut self) -> bool {
            let mut input = String::new();

            while let Ok(cnt) = self.read.read_line(&mut input) {
                if cnt == 0 {
                    break;
                }
                let line = input.trim();
                if !line.is_empty() && line.matches("=").count() == line.len() {
                    return true;
                }
                input.clear();
            }

            false
        }
    }

    impl<ReadType: BufRead> IOScanner<ReadType> {
        pub fn new(read: ReadType) -> IOScanner<ReadType> {
            IOScanner {
                read,
                buffer: Vec::<String>::default(),
            }
        }
    }
}
