#include "testlib.h"
#include <cmath>
 
const double EPS = 1.0E-9;
const double MIN_A = 0.0 - 2 * EPS;
const double MAX_A = 1e6 + 2 * EPS;
 
int main(int argc, char *argv[]) {
    setName("compare two doubles, maximal absolute error = %.10f", EPS);
    registerTestlibCmd(argc, argv);
 
    double ja = ans.readDouble(MIN_A, MAX_A, "ja");
    double pa = ouf.readDouble(MIN_A, MAX_A, "pa");
 
    if (fabs(ja - pa) > EPS * (1.0 + 1E-15))
        quitf(_wa, "expected %.10f, found %.10f", ja, pa);
 
    quitf(_ok, "answer is %.10f", ja);
}