#include "testlib.h"
#include <array>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iostream>
#include <string>
#include <utility>
#include <vector>

using namespace std;
constexpr int N = 1000;
constexpr int MAXC = 1000;

using Point = pair<int, int>;

struct Test {
  vector<Point> a;
  Test() : a(vector<Point>()) {}
  Test (vector<Point> _a) : a(_a) {}
  void out() const {
    cout << a.size() << "\n";
    for (auto const &p: a) {
      cout << p.first << " " << p.second << "\n";
    }
  }
};

Test rand_uniform(int n, int maxc, int ox_points) {
  vector<Point> a;
  for (int i = 0; i < n; ++i) {
    int x = rnd.next(-maxc, maxc);
    int y = rnd.next(-maxc, maxc);
    if (i < ox_points) {
      y = 0;
    }
    a.push_back({x, y});
  }
  shuffle(a.begin(), a.end());
  return { a };
}

int main(int argc, char* argv[]) {
  registerGen(argc, argv, 1);
  Test t;
  int k = 2;
  if (!strcmp(argv[1], "uniform")) {
    const int n = atoi(argv[k++]);
    const int maxc = atoi(argv[k++]);
    int ox_points = 0;
    if (k < argc) {
      ox_points = atoi(argv[k++]);
    }
    t = rand_uniform(n, maxc, ox_points);
  } else if (!strcmp(argv[1], "hand")) {
    vector<Point> a;
    while (k + 2 <= argc) {
      a.push_back( { atoi(argv[k]), atoi(argv[k+1]) });
      k += 2;
    }
    t = Test { a };
  } else {
    return 1;
  }
  t.out();
  return 0;
}