/**
 * Validator for problem min-adj-swaps.
 */

#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);
  validator.addFeature("k_negative_cast_to_int");
  int nt = inf.readInt(1, 100'000, "number of tests");
  inf.readEoln();
  int total_l = 0;
  bool k_negative_cast_to_int = false;
  for (int i = 0; i < nt; ++i) {
    setTestCase(i + 1);
    auto s = inf.readToken("[1-9]{1,100000}", "s[]");
    inf.readSpace();
    unsigned long long k = inf.readLong(0ULL, 1'000'000'000'000'000'000ULL, "k[]");
    if (((int) k) < 0) {
      k_negative_cast_to_int = true;
    }
    inf.readEoln();
    total_l += (int) s.length();
    ensure(total_l <= 100'000);
  }
  inf.readEof();
  if (k_negative_cast_to_int) {
    validator.feature("k_negative_cast_to_int");
  }
  return 0;
}