#include "testlib.h"
#include <ranges>

struct Test {
    std::vector<uint32_t> a;
    uint32_t s, f;
};

std::ostream& operator<<(std::ostream& out, const Test& test) {
    out << test.a.size() << '\n';
    for (uint32_t i = 0; i < test.a.size(); ++i)
        out << test.a[i] << (i + 1 == test.a.size() ? '\n' : ' ');
    return out << test.s << ' ' << test.f;
}

Test generate_random() {
    uint32_t n = opt<uint32_t>("n");
    uint32_t A = opt<uint32_t>("A");
    Test test;
    test.a = std::ranges::views::iota(static_cast<uint32_t>(1), n + 1) | std::ranges::views::transform([A](uint32_t){return static_cast<uint32_t>(rnd.next(static_cast<uint32_t>(1), A));}) | std::ranges::to<std::vector<uint32_t>>();
    test.s = rnd.next(static_cast<uint32_t>(1), n);
    do {
        test.f = rnd.next(static_cast<uint32_t>(1), n);
    } while (test.s == test.f);
    return test;
}

Test generate_repeat(int argc) {
    Test test;
    uint32_t n = opt<uint32_t>("n");
    test.s = opt<uint32_t>("s");
    test.f = opt<uint32_t>("f");
    --argc;
    test.a = std::ranges::views::iota(static_cast<uint32_t>(0), n) | std::ranges::views::transform([argc](uint32_t i){return opt<uint32_t>(5 + i % (argc - 4));}) | std::ranges::to<std::vector<uint32_t>>();
    return test;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);rnd.next(134235);
    std::string type = opt<std::string>("type");
    Test test;
    if (type == "random")
        test = generate_random();
    else if (type == "repeat")
        test = generate_repeat(argc);
    else
        ensuref(false, "%s", std::format(R"(unknown test type: "{}")", type).c_str());
    std::cout << test << '\n';
}
