#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <algorithm>
#include <iterator>
#include <string>
#include <cctype>

struct Edge {
    uint32_t m, s, f;
};

std::string shuffle_cases(std::string str) {
    static std::mt19937 rng(std::chrono::high_resolution_clock::now().time_since_epoch().count());
    std::transform(str.begin(), str.end(), str.begin(), [&rng](char c) -> char {
        if (std::uniform_int_distribution<uint8_t>(0, 1)(rng))
            return static_cast<char>(std::tolower(c));
        else
            return static_cast<char>(std::toupper(c));
    });
    return str;
}

std::ostream& operator<<(std::ostream& out, const Edge edge) {
    return out << shuffle_cases("Kaban") << '-' << edge.m << ' ' << edge.s << ' ' << edge.f;
}

uint32_t gcd(uint32_t a, uint32_t b) {
    while (b) {
        a %= b;
        std::swap(a, b);
    }
    return a;
}

int main() {
    uint32_t n;
    std::cin >> n;
    std::vector<int32_t> a(n);
    for (uint32_t i = 0; i < n; ++i) {
        std::cin >> a[i];
    }
    uint32_t s, f;
    std::cin >> s >> f;
    std::vector<Edge> edges;
    while (s != f) {
        uint32_t c = s;
        uint32_t m = 0;
        while (c != f) {
            uint32_t cc = c;
            if (c < f) ++cc;
            else --cc;
            uint32_t aa = abs(a[c - 1] - a[cc - 1]);
            if (aa == 1)
                goto fail;
            uint32_t mm = gcd(m, aa);
            if (mm == 1)
                break;
            m = mm;
            c = cc;
        }
        edges.push_back({std::max<uint32_t>(2, m), s, c});
        s = c;
    }
fail:
    if (s != f)
        std::cout << shuffle_cases("Impossible");
    else
        std::copy(edges.begin(), edges.end(), std::ostream_iterator<Edge>(std::cout, "\n"));
}

