// Author: Ivan Kazmenko (gassa@mail.ru)
// Validator for problem "read-ordinal"
module validate;
import std.algorithm;
import std.conv;
import std.exception;
import std.range;
import std.string;
import testlib;

immutable int minN =  0;
immutable int maxN = 15;

int go (ref string s)
{
	int balance = 0;
	enforce (!s.empty && s.front == '{');
	s.popFront;
	int [] v;
	bool start = false;
	while (s.front != '}')
	{
		if (start)
		{
			enforce (s.front == ',');
			s.popFront;
			enforce (!s.empty);
		}
		else
		{
			start = true;
		}
		v ~= go (s);
	}
	s.popFront;
	auto n = v.length.to !(int);
	sort (v);
	enforce (equal (v, n.iota));
	return n;
}

void main (string [] args)
{
	initTestlib !(TestlibRole.validator) (args);

	auto s = inFile.readln.strip;
	auto n = go (s);
	enforce (s.empty);
	enforce (minN <= n && n <= maxN);

	inFile.checkEof ();
}
