#include "testlib.h"
 
#include <iostream>
#include <set>
#include <cassert>
#include<vector>
#include<random>

using ll = long long; 
using namespace std;
void dfs_dist(vector<vector<pair<int, ll>>>& tree, vector<ll>& dists, int v, ll dist)
{
	dists[v] = dist;
	for (auto el : tree[v])
	{
		if (dists[el.first] == -1)
			dfs_dist(tree, dists, el.first, dist + el.second);
	}
}
void my_shuffle(vector<int>&v)
{
    int n=v.size();
    for(int i=0; i<4*n; i++)
    {
        int el1=rnd.next(n);
        int el2=rnd.next(n);
        std::swap(v[el1], v[el2]);
    }
}
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	const int maxn = atoi(argv[1]);
	const int maxk = atoi(argv[2]);
	int ch = atoi(argv[3]);
 
	cout << maxn << endl;
	vector<vector<pair<int,ll>>>tree(maxn);
	vector<int>perm(maxn);
	for(int i=0; i<maxn; i++)
	   perm[i]=i;
	my_shuffle(perm);
	for (int i = 1; i < maxn; i++)
	{
	    auto v1=perm[i-1], v2=perm[i];
		auto len = rnd.next(maxk) + 1;
		tree[v2].push_back({v1,len});
		tree[v1].push_back({v2,len});
		
	}
	vector<vector<ll>>my_dists(maxn, vector<ll>(maxn, -1));
	for (int root = 0; root < maxn; root++)
	{
		dfs_dist(tree, my_dists[root], root, 0);
	}
	if(ch)
	{
	int i1=rnd.next(maxn/2-2);
	int i2=rnd.next(maxn/2-2);
	if(i1==i2)
	   i2++;
	my_dists[i1][i2]++;
	my_dists[i2][i1]++;
	}
	for(int i=0; i<maxn; i++)
	{
	    for(int j=0; j<maxn; j++)
	    {
	        if(j!=maxn-1)
	           cout<<my_dists[i][j]<<' ';
	        else
	           cout<<my_dists[i][j]<<'\n';
	    }
	}
}