#include "testlib.h"
 
#include <iostream>
#include <set>
#include <cassert>
#include<vector>
 
using ll = long long; 
using namespace std;
void dfs_dist(vector<vector<pair<int, ll>>>& tree, vector<ll>& dists, int v, ll dist)
{
	dists[v] = dist;
	for (auto el : tree[v])
	{
		if (dists[el.first] == -1)
			dfs_dist(tree, dists, el.first, dist + el.second);
	}
}
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	const int maxn = atoi(argv[1]);
	const int maxk = atoi(argv[2]);
 
	cout << maxn << endl;
	vector<vector<pair<int,ll>>>tree(maxn);
	for (int i = 1; i < maxn; i++)
	{
	    auto vert = rnd.next(i);
		auto len = rnd.next(maxk) + 1;
		tree[i].push_back({vert,len});
		tree[vert].push_back({i,len});
		
	}
	vector<vector<ll>>my_dists(maxn, vector<ll>(maxn, -1));
	for (int root = 0; root < maxn; root++)
	{
		dfs_dist(tree, my_dists[root], root, 0);
	}
	int i1=rnd.next(maxn/2-2);
	int i2=rnd.next(maxn/2-2);
	if(i1==i2)
	   i2++;
	my_dists[i1][i2]++;
	my_dists[i2][i1]++;
	for(int i=0; i<maxn; i++)
	{
	    for(int j=0; j<maxn; j++)
	    {
	        if(j!=maxn-1)
	           cout<<my_dists[i][j]<<' ';
	        else
	           cout<<my_dists[i][j]<<'\n';
	    }
	}
}