#include <iostream>
#include<set>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<cassert>
#include<ctime>
#include<utility>
#include<queue>

using namespace std;
using ll = long long;

void dfs_dist(vector<vector<pair<int, ll>>>& tree, vector<ll>& dists, int v, ll dist)
{
	dists[v] = dist;
	for (auto el : tree[v])
	{
		if (dists[el.first] == -1)
			dfs_dist(tree, dists, el.first, dist + el.second);
	}
}

int main() 
{
	int n;
	cin >> n;
	vector<vector<ll>>mtr(n, vector<ll>(n));
	vector<int>intree(n);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			cin >> mtr[i][j];
	vector<vector<pair<int,ll>>>tree(n);
	vector<ll>dists(n, 1e9+7);
	for (int i = 0; i < n; i++)
	{
		int cur = -1;
		for (int j = 0; j < n; j++)
		{
			if (!intree[j])
				if (cur == -1 || dists[cur] > dists[j])
					cur = j;
		}
		if (i > 0)
		{
			for (int j = 0; j < n; j++)
			{
				if (intree[j])
					if (mtr[j][cur] == dists[cur])
					{
						tree[j].push_back({ cur, dists[cur] });
						tree[cur].push_back({ j, dists[cur] });
				//		cout << j << ' ' << cur << '\n';
						break;
					}
			}
		}
		intree[cur] = 1;
		for (int j = 0; j < n; j++)
			dists[j] = min(dists[j], mtr[cur][j]);
	}
	vector<vector<ll>>my_dists(n, vector<ll>(n, -1));
	for (int root = 0; root < n; root++)
	{
		dfs_dist(tree, my_dists[root], root, 0);
	}
//	outp(my_dists);
	if (mtr == my_dists)
		cout << "Yes \n";
	else
		cout << "No \n";
}